/******************************************************************************/
/* Files to Include                                                           */
/******************************************************************************/

#if defined(__XC)
    #include <xc.h>         /* XC8 General Include File */
#elif defined(HI_TECH_C)
    #include <htc.h>        /* HiTech General Include File */
#endif

#include <stdint.h>        /* For uint8_t definition */
#include <stdbool.h>       /* For true/false definition */

#include "system.h"        /* System funct/params, like osc/peripheral config */
#include "user.h"          /* User funct/params, such as InitApp */
#include "mcc_generated_files/mcc.h"
/******************************************************************************/
/* User Global Variable Declaration                                           */
/******************************************************************************/

/* i.e. uint8_t <variable_name>; */
/******************************************************************************/
/* User Global deffinitions                                          */
/******************************************************************************/

/*****************************************************************************
*fonction qui calcule le temps d'attente entre deux alumage du pi en fonction de la valeure analogique lu sur la pin annalogue
*******************************************************************************/
int calcule_attente(void)
{//ici le convertisseur AN a une rsolution de 10bits -> 1023 donc le cantum= 5v / 1023=4.89mv
  int valeur=0;
   
  valeur= (convertion_annalogique*10800)/1023; //donne la valeur en secondes :max 1023->3h
  return valeur;
}
/******************************************************************************/
/* Main Program                                                               */
/******************************************************************************/


void main(void)
{
   
 SYSTEM_Initialize();                   //configuration de l'oscillateur , despin, timer1 , adc, interuptions...
 LATA = 0x00;                           //toutes les sorties  0, les deux mosfets sont activs , le pi est alliment

                          
    
        convertion_annalogique=ADC_GetConversion(channel_AN0);
        if (convertion_annalogique>50)              //si la convertion est infrieur  50 , R5 absente , donc mode timer dsactiv
        {
            mode_timer=1; //en mode timer , on configure le temp entre deux redmarage du pi
            temps_timer=calcule_attente();
        }

 while (entree_bouton==0);              //tant que le bouton est maintenue appuy on attend, pour viter toutes interuptions involontaires
 INTCONbits.GIE=1;                      //validation des interuptions
 INTCONbits.PEIE=1;
 
    while(1)
    {

        if(envoi_arret_pi==1)           //le bouton  t press (plus de 3s pour etre pris en compte par le pi)donc
        {                               //envoi d'un signal haut  au pi pour lui signaler une demande d'arret
           //while (PORTAbits.RA1==1)   //tant q'un signal est prsent sur RA1 on reste en entre
           Direction_Pin_Pi=0;          //on passe RA1 en sortie
           INTCONbits.PEIE=0;           //on suspend les interruptions peripheriques

           while (entree_bouton==0)     //tant que le bouton est maintenue appuy
           {
               Sortie_Pi=1;             //envoi d'un niveau 1 sur ra1 pour indiquer au pi une demande d'arret
           }
           Sortie_Pi=0;
           Direction_Pin_Pi=1;          //on passe RA1 en entre
          INTCONbits.PEIE=1;            //on revalide les interruptions peripheriques
          envoi_arret_pi=0;             //effeacement du flag, la demande d'arret a t  envoyer
        }

        if ((arret_demande==1)&(compt>=temps_attente))//la coupure a ete demmand par le pi et 60s ce sont ecoules , on peut arrter le pic et le pi
        {
           
           mosfet_alim =1;              //coupure de l'alim du pic
           arret_demande=0;             
        }
    }

}

