/**
  Generated Pin Manager File

  Company:
    Microchip Technology Inc.

  File Name:
    pin_manager.c

  Summary:
    This is the Pin Manager file generated using MPLAB Code Configurator

  Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB Code Configurator - v2.25.2
        Device            :  PIC12F1840
        Driver Version    :  1.02
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.34
        MPLAB             :  MPLAB X v2.35 or v3.00
*/

/*
Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
*/

#include <xc.h>
#include "pin_manager.h"
#include "../user.h"

void PIN_MANAGER_Initialize(void)
{
    LATA = 0x00;
    TRISA = 0x2B;
    ANSELA = 0x01;
    WPUA = 0x00;

    OPTION_REGbits.nWPUEN = 0x01;

    APFCON = 0x00;

    // enable interrupt-on-change individually    
    IOCAN1 = 1;
    IOCAP1 = 1;
    IOCAN5 = 1;
    
    // enable interrupt-on-change globally
    INTCONbits.IOCIE = 1;        
        
}
void PIN_MANAGER_IOC(void)
{
    /*Interuption sur la pin RA1 ,impultion infrieur  2s on reset le watchdog,
     * impultion suprieure  2s ,demande d'arret du pic et du pi*/
    if(((IOCAN1 == 1) || (IOCAP1 == 1)) && (IOCAF1 == 1))   //interuption sur RA1 sur front montant et descendant
    {
         __delay_ms(400);                                   //anti rebonds
        //@TODO Add handling code for IOC on pin RA1
        if((premier_front==1)&(compt>=2))                   //impultion sup  2s = demande d'arret du pi et du pic
        {
            
            arret_demande=1;
            compt=0;
        }
        else if((premier_front==1) &(compt<2))              //impultion inf  2s = reset du watcdog
        {
            premier_front=0;
            compt=0;
        }
        else                                                //premier front , on reset le compteur pour compter la largeur de l'impultion
        {
            premier_front=1;
            compt=0;
        }
        // clear interrupt-on-change flag
        IOCAF1 = 0;
    }

    /*front montant sur RA5, on demande au pi de s'arrter*/
    else if((IOCAN5 == 1) && (IOCAF5 == 1))
    {
        //@TODO Add handling code for IOC on pin RA5
        __delay_ms(200);

        envoi_arret_pi=1;
        // clear interrupt-on-change flag
        IOCAF5 = 0;        
    }
}
/**
 End of File
*/