/*main.c
*Programme de getion d'un watchdog (chien de garde )et de getion de l'alimentation  pour un *Raspberry.
*Il y a deux modes de fonctionement :
- un mode timer qui ralimente auto matiquement et rgulirement  le Pi et getion d'alimentation
- un mode normal avec getion alimentaion et watchdog
*La getion de l'alimentation se fait par le bouton de mise en route : un premier appui demare le p 
*et le pi , un second appui long enverra au pi une demande de halt et aprs une tempo coupera *l'alimentation Pi en mode timer et l'alim general en mode "normal".
*
*Le programme gre deux sorties qui commandent des mosfets de getion de l'alimentation, une *entre pour le bouton de getion alim et une pin entre et sortie pour l'interface avec le Pi.
*
*Il gre galement une base de temps avec la variable comp qui doit etre incrmente chaques *secondes, */ 



/******************************************************************************/
/* fichiers  inclure                                                           */
/******************************************************************************/


#include <stdint.h>        /* For uint8_t definition */
#include <stdbool.h>       /* For true/false definition */



#define  delay_watchdog 120             //dureen secondes du watchdog au bout de laquelle il y a reset du pi
#define  temps_attente  50              //delay en seconde  aprs une demande d'exinction par le pi , pour laisser le temps  celui-ci de s'teindre proprement

//definissez ici les pin utilises , changez juste le numrots en fonction de la pin
#define  mosfet_alim   1
#define  mosfet_pi     2
#define  entree_Pi     3//doit etre la meme que Sortie_pi
#define  Sortie_Pi     3
#define  entree_bouton 4
#define  entree_analogique 5

/******************************************************************************/
/* User Global Variable Declaration                                           */
/******************************************************************************/
uint8_t compt=0;                        //compteur de secondes
int convertion_annalogique=0;
int temps_timer;                   //variable de stockage du temps en seconde entre deux redemarage du pi

//diffrents flags utilisss pour les diffrentes tapes du programmes
bool mode_timer=0;
bool new_seconde=0;
bool pi_isr=0;
bool premier_front=0;
bool arret_demande=0;
bool envoi_arret_pi=0;

/****************************************************************************
*Les fonctions qui suivent servent  interafer le programme avec le c choisi
*vous devait complter ces fonctions enfonction du matriel utilis
****************************************************************************


/*****************************************************************************
 *fonction d'initialisation de l 'oscillateur
 *****************************************************************************/
void OSCILLATOR_Initialize(void)
{
    //ajouter ici votre code

}

/*****************************************************************************
 *fonction d'initialisation des pins :
 *-1pin en entre analogique
 *-2pins en sorties pour la commandes des mosfets
 *-1pin en entre numrique pour lire les commande du pi(servira aussi  envoyer des commande au pi aprs reconfiguration du sens )
 *-1pin en entre numrique pour lire l'tat du bouton
 ******************************************************************************/
void PIN_MANAGER_Initialize(void)
{
 //ajouter ici votre code

}

/*****************************************************************************
 *fonction d'initialisation d'un timer ou rtc
 *cette fonction doit gnrer une intruption ou une fonction qui met  jour le flag new_seconde
 * chaque nouvelle secondes
 ******************************************************************************/
void TMR_Initialize(void)
{
  //ajouter ici votre code

}

/*****************************************************************************
*fonction d'initialisation du module de convertion analogique-numerique sur la pin entree_analogique
*******************************************************************************/
void ADC_Initialize(void)
{
  //ajouter ici votre code

}

/**************************************************************************************************
*fonction d'initialisation des intruptions:
*-1 interuption sur front montant pour la pin entree_bouton,
* la fonction appele par l'intruption doit metre  1 le flag envoi_arret_pi
*-1 interuption sur front montant et descendant pour la pin entree_pi,
* la fonction appele par l'intruption doit metre le flag pi_isr  1
*
***************************************************************************************************/
void ISR_Initialize(void)
{
  //ajouter ici votre code

}

/*****************************************************************************
*fonction de desactivations des interuptions
**************************************************************************** */
void ISR_Disable(void)
{
    //ajouter ici votre code
}

/*****************************************************************************
*fonction  d'activations des interuptions
**************************************************************************** */
void ISR_Enable(void)
{
    //ajouter ici votre code
}
/******************************************************************************
 *
 *
 ******************************************************************************/
void direction_pin (int pin, int direction)
{
    if (direction==0)
    {
        //ajouter ici votre code pour metre la pin en sortie

    }
    else
    {
        //ajouter ici votre code pour metre la pin en entre

    }

}

/*****************************************************************************
*fonction d'criture d'une pin en sortie
*
*******************************************************************************/
void ecriture_pin_sortie(int pin,int valeur)
{
  //ajouter ici votre code

}

/*****************************************************************************
*fonction de lecture d'une pin en entre numrique
*
*******************************************************************************/
int lecture_pin_entree(int pin)
{
  int valeur=0;     //variable qui doit etre mise  jour avec la valeur de la pin
  //ajouter ici votre code


  return valeur;
}

/*****************************************************************************
*fonction de lecture d'une pin en entre analogique
*retourne la valeur de la convertion analogique-numrique
*******************************************************************************/
int lecture_pin_annalogique(int pin)
{
  int valeur=0;     //variable qui doit etre mise  jour avec la valeur de la convertion
  //ajouter ici votre code


  return valeur;
}

/*****************************************************************************
*fonction qui calcule le temps d'attente entre deux alumage du pi en fonction de la valeure analogique lu sur la pin annalogue
*******************************************************************************/
int calcule_attente(void)
{
  int valeur=0;
    //ajouter ici votre code

  return valeur;
}


/******************************************************************************
*Dbut du programme principal
******************************************************************************/

/******************************************************************************/
/* Main Program                                                               */
/******************************************************************************/
void main(void)
{
   
    OSCILLATOR_Initialize();
    PIN_MANAGER_Initialize();
    TMR_Initialize();
    ADC_Initialize();                       //configuration de l'oscillateur , despin, timer1 , adc, interuptions...
    ecriture_pin_sortie(mosfet_alim,0);     //toutes les sorties  0, les deux mosfets sont activs , le pi est alliment
    ecriture_pin_sortie(mosfet_pi,0);

    if(mode_timer)                          //en mode timer , on configure le temp entre deux redmarage du pi
    {
        convertion_annalogique=lecture_pin_annalogique;
        temps_timer=calcule_attente();
    }

    ISR_Initialize();                       //configure les intruptions et les mets en fonction.

    while (lecture_pin_entree(entree_bouton)==0);//tant que le bouton est maintenue appuy on attend, pour viter toutes interuptions involontaires
 
 
    while(1)
    {
        if(pi_isr)                                              //un front a t detect sur la pin entree_pi
        {
            if((premier_front==1)&(compt>=2))                   //impultion sup  2s = demande d'arret du pi et du pic
            {
            arret_demande=1;
            compt=0;
            }
            else if((premier_front==1) &(compt<2))              //impultion inf  2s = reset du watcdog
            {
            premier_front=0;
            compt=0;
            }
            else                                                //premier front , on reset le compteur pour compter la largeur de l'impultion
            {
            premier_front=1;
            compt=0;
            }
             
            pi_isr=0;                                           //on reset le flag d'interuption
        }


        if(new_seconde &(!mode_timer))               //une seconde est passe on incrmente compt puis on vrifie le compteur du watchdog, sauf en mode timer o le redmaarrage ce ferat au prochain cycle
        {
        compt++;                      
          if(arret_demande==0)        //on effectue la suite seulement si la coupure de l'alimentation n'est pas demande
           {
            if (compt==delay_watchdog)//1minute est passe sans reset du compteur ,donc coupe de l'alim du pi
            {
            ecriture_pin_sortie(mosfet_pi,1);
            }
           }
          if (mosfet_pi ==1)          //reset du pi effectu il y a 1s , on reconnect l'alimentation du pi
           {
           ecriture_pin_sortie(mosfet_pi,0);
           compt=0;
           }          
         new_seconde=0;
        }


        if(envoi_arret_pi==1)           //le bouton  t press (plus de 3s pour etre pris en compte par le pi)donc
        {                               //envoi d'un signal haut  au pi pour lui signaler une demande d'arret         
           
           ISR_Disable();               //on suspend les interruptions peripheriques
		   direction_pin(Sortie_Pi,0);  //on passe Sortie_Pi en sortie

           while (lecture_pin_entree(entree_bouton)==0)//tant que le bouton est maintenue appuy
           {
               ecriture_pin_sortie(Sortie_Pi,1);//envoi d'un niveau 1 sur ra1 pour indiquer au pi une demande d'arret
           }
           ecriture_pin_sortie(Sortie_Pi,0);
           direction_pin(Sortie_Pi,1);  //on passe Sortie_Pi en entre
          ISR_Enable();                 //on revalide les interruptions peripheriques
          envoi_arret_pi=0;             //effeacement du flag, la demande d'arret a t  envoyer
        }

        if ((arret_demande==1)&(compt>=temps_attente))//la coupure a ete demmand par le pi et 60s ce sont ecoules , on peut arrter le pic et le pi
        {
            if(!mode_timer)                //mode normal , on coupe l'alimentation general
            {
              ecriture_pin_sortie(mosfet_alim,1);//coupure de l'alim du pic
            }
            else                           //mode timer , on coupe que le pi
            {
             ecriture_pin_sortie(mosfet_pi,1);//coupure de l'alim du pi
            }
           arret_demande=0;             
        }

        if(mode_timer&(compt>=temps_timer))  //en mode timer on redmare le pi si le temps d'attente est dpass, si la pi est deja allum on attent le prchain cycle
        {
            if(lecture_pin_entree(mosfet_pi)==1)
            {
             ecriture_pin_sortie(mosfet_pi,0);
            }
            compt=0;
        }


    }//while(1)

}//main()
